#import "XeeMultiImage.h"
#import "XeeBitmapImage.h"

#include "libjpeg/jpeglib.h"

@class XeeTileImage;

@interface XeeJPEGImage:XeeMultiImage
{
	BOOL jpeg_created;
	struct jpeg_decompress_struct cinfo;
	struct jpeg_error_mgr jerr;

	uint8 *ycbcr_buffers;
	JSAMPLE *y_buf,*cb_buf,*cr_buf;
	JSAMPROW y_lines[16],cb_lines[16],cr_lines[16];
	JSAMPARRAY image[3];

	XeeTileImage *mainimage;

	uint8 *thumb_ptr;
	int thumb_len;
}

+(NSArray *)fileTypes;
+(BOOL)canOpenFile:(NSString *)name firstBlock:(NSData *)block attributes:(NSDictionary *)attributes;

-(SEL)initLoader;
-(void)deallocLoader;
-(SEL)startLoading;
-(SEL)loadYUV;
-(SEL)loadRGB;

-(int)losslessSaveFlags;
-(BOOL)losslessSaveTo:(NSString *)path flags:(int)flags;

@end

@interface XeeBrokenJPEGImage:XeeJPEGImage
{
}

+(BOOL)canOpenFile:(NSString *)name firstBlock:(NSData *)block attributes:(NSDictionary *)attributes;
-(SEL)initLoader;

@end

@interface XeeDirectJPEGImage:XeeBitmapImage
{
}
 
-(id)initWithBytes:(const void *)bytes length:(int)len;
-(id)initWithData:(NSData *)data;
 
@end

